home | help
libcanlock(3)		     libcanlock 3.3.2 manual		   libcanlock(3)

NAME
     cl_verify_multi  -  Check multiple keys against multiple locks with libcan-
     lock

SYNOPSIS
     #include <libcanlock-3/canlock.h>

     int cl_verify_multi(cl_hash_version *rejected_hash_list,
			 const char *c_key_list,
			 const char *c_lock_list);

     Supported values for reject_hash (by version 3.3.0 of libcanlock):
     CL_SHA1 CL_SHA224 CL_SHA256 CL_SHA384 CL_SHA512

DESCRIPTION
     Attention: This function is not available with versions before 3.3.0.

     The cl_verify_multi() function checks a list of <c-key> elements against  a
     list of <c-lock> elements according to the algorithm defined by RFC 8315 in
     Section 3.5.

     Hash  algorithms for <scheme> that should be rejected can be specified with
     rejected_hash_list.  Specify either NULL, to  accept  all	hash  algorithms
     supported	by  libcanlock,  or a pointer to an array terminated with CL_IN-
     VALID.
     A reject list is used instead of an accept list so that programs using lib-
     canlock automatically inherit support for stronger hash algorithms that may
     be added in the future.

     The <c-key> elements must be specified with c_key_list and the and <c-lock>
     elements with c_lock_list.  Both must be strings  where  the  elements  are
     separated by single SP (space) characters.
     The  output  of  the  header  field  parser  canlock-hfp  is  suitable  for
     c_key_list and c_lock_list.  The function cl_hp_parse_field() from the lib-
     canlock-hp library can be used to execute the parser.

RETURN VALUE
     If one of the keys matches one of the locks, zero is returned.
     All other values indicate an error.

AUTHORS
     Michael Baeuerle

REPORTING BUGS
     Report bugs to <mailto:michael.baeuerle@gmx.net>.

STANDARDS
     libcanlock tries to comply with the following standards:

     RFC 5537, RFC 6234, RFC 8315

SEE ALSO
     cl_clear_secret(3),  cl_get_key(3),  cl_get_lock(3),  cl_split(3),  cl_ver-
     ify(3),  cl_hp_get_field(3),  cl_hp_unfold_field(3),  cl_hp_parse_field(3),
     canlock(1), canlock-hfp(1), canlock-mhp(1)

Unix				   2026-06-22			   libcanlock(3)

home | help